	include	dos.mac
	dseg
	usenames	<ems_bx, ems_dx>
	extrn	ems_bx:word, ems_dx:word
time_init	dw	0	; 0 to enable, 1 to turn off
bios_count_hi   dw	0
saved_mem_strat	dw	0
saved_link	db	0
is_dv		db	0
ems_name	db	"EMMXXXX0"
	endds

	pseg

cproc	try_ems, <si, di>
	mov	ax, 3567h		; get addr of ems handler in es:bx
	int	21h
	mov	cx, 8
	mov	di, 0ah
	mov	si, offset ems_name	; ds:si now points to "EMMXXXX0"
repe	cmpsb
badems:	mov	ax, 0			; assume it's bad
	jne	done			; didn't match, no ems
	mov	ah, 40h			; get status
	int	67h			; it's ok
	or	ah, ah
	jnz	badems			; error
	mov	ah, 46h			; get version #
	int	67h
	or	ah, ah
	jnz	badems			; return version # in al
done:
cend

cproc	ems_call
parmw	func
parmw	val
parmw	handle
	mov	ax, func
	mov	bx, val
	mov	dx, handle
	int	67h
	mov	al, ah			; move error code to ax
	xor	ah, ah
	mov	ems_bx, bx
	mov	ems_dx, dx
cend

cproc	ems_copy, <si>
parmd	movedata
	mov	ax, 5700h
	push	ds
	lds	si, movedata
	int	67h
	pop	ds
	xor	ah, ah
cend

	endps
	end
